Annotation of openbsd/fw_update/fw_install.sh, Revision 1.40
1.1 afresh1 1: #!/bin/ksh
1.36 afresh1 2: # $OpenBSD$
1.1 afresh1 3: set -e
4:
1.38 afresh1 5: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
6: #
7: # Permission to use, copy, modify, and distribute this software for any
8: # purpose with or without fee is hereby granted, provided that the above
9: # copyright notice and this permission notice appear in all copies.
10: #
11: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
12: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
13: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
14: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
15: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
16: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
17: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
18:
1.24 afresh1 19: # Fake up some things from install.sub that we don't need to actually do
1.22 afresh1 20: prefetcharea_fs_list() {
1.27 afresh1 21: echo "${DESTDIR}/tmp"
1.22 afresh1 22: }
23:
1.8 afresh1 24: # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
25:
26: # Create a temporary directory based on the supplied directory name prefix.
27: tmpdir() {
28: local _i=1 _dir
29:
30: until _dir="${1?}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
31: ((++_i < 10000)) || return 1
32: done
33: echo "$_dir"
34: }
1.6 afresh1 35:
36: # Run a command ($2+) as unprivileged user ($1).
37: # Take extra care that after "cmd" no "user" processes exist.
38: #
39: # Optionally:
40: # - create "file" and chown it to "user"
41: # - after "cmd", chown "file" back to root
42: #
43: # Usage: do_as user [-f file] cmd
44: do_as() {
45: (( $# >= 2 )) || return
46:
47: local _file _rc _user=$1
48: shift
49:
50: if [[ $1 == -f ]]; then
51: _file=$2
52: shift 2
53: fi
54:
55: if [[ -n $_file ]]; then
56: >$_file
57: chown "$_user" "$_file"
58: fi
59:
60: doas -u "$_user" "$@"
61: _rc=$?
62:
63: while doas -u "$_user" kill -9 -1 2>/dev/null; do
64: echo "Processes still running for user $_user after: $@"
65: sleep 1
66: done
67:
68: [[ -n $_file ]] && chown root "$_file"
69:
70: return $_rc
71: }
72:
73: unpriv() {
74: do_as _sndio "$@"
75: }
76:
77: unpriv2() {
78: do_as _file "$@"
79: }
80:
1.33 afresh1 81: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
1.34 afresh1 82: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
1.33 afresh1 83: FWDIR=${FWDIR:-$VNAME}
1.1 afresh1 84:
1.14 afresh1 85: # TODO: We need the firmware for the system we just installed
86: # not the one we booted from. For example:
87: # * booting from a snapshot bsd.rd that thinks it is the 7.0 release
88: # will install the firmware from the 7.0 directory instead of
89: # from the snapshots dir.
90: # If they're using sysupgrade, then the installer kernel will be correct.
91: # If we're doing this in the installer we can check what they picked
92: # for downloading sets and use that value.
93: # Otherwise, the fw_update after first boot will fix it up for us.
94:
1.7 afresh1 95: HTTP_FWDIR=$FWDIR
1.30 afresh1 96: set -- sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot
1.7 afresh1 97: [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots
98:
99: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
100: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.37 afresh1 101: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
1.1 afresh1 102:
1.20 afresh1 103: # TODO: support srclocal installation of firmware somehow
1.35 afresh1 104: fw_install() {
1.24 afresh1 105: local _src=$1 _tmpfs_list _tmpfs _tmpsrc \
1.27 afresh1 106: _t=Get _cfile="/tmp/SHA256" _pkgdir=${DESTDIR}/var/db/pkg \
1.25 afresh1 107: _f _r _remove _i _installed
108: local _srclocal=false _unpriv=unpriv
1.26 afresh1 109:
1.15 afresh1 110: local _d _drivers=$(
1.11 afresh1 111: last=''
1.15 afresh1 112: while read _d _m; do
1.11 afresh1 113: grep=grep
1.15 afresh1 114: [ "$last" = "$_d" ] && continue
115: [ "$_m" ] || _m="^$_d[0-9][0-9]* at "
116: [ "$_m" = "${_m#^}" ] && grep=fgrep
117: $grep -q "$_m" /var/run/dmesg.boot || continue
118: echo $_d
119: last=$_d
1.37 afresh1 120: done < $FWPATTERNS
1.11 afresh1 121: )
122:
123: if [ -z "$_drivers" ]; then
1.22 afresh1 124: echo "No devices found which need firmware files to be downloaded."
1.11 afresh1 125: return
126: fi
1.1 afresh1 127:
1.22 afresh1 128: ! _tmpfs_list=$(prefetcharea_fs_list) &&
129: echo "Cannot determine prefetch area" >&2 && return
130:
131: for _tmpfs in $_tmpfs_list; do
132: # Try to clean up from previous runs, assuming
133: # the _tmpfs selection yields the same mount
134: # point.
135: for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do
136: [[ -d $_tmpsrc ]] && rm -r $_tmpsrc
137: done
138:
139: # Create a download directory for the firmware and
140: # check that the _sndio user can read files from
141: # it. Otherwise cleanup and skip the filesystem.
142: if _tmpsrc=$(tmpdir "$_tmpfs/firmware"); then
143: (
144: >$_tmpsrc/t &&
145: $_unpriv cat $_tmpsrc/t
146: ) >/dev/null 2>&1 && break ||
147: rm -r $_tmpsrc
148: fi
149: done
1.1 afresh1 150:
1.11 afresh1 151: [[ ! -d $_tmpsrc ]] &&
1.22 afresh1 152: echo "Cannot create prefetch area" >&2 && return 1
1.1 afresh1 153:
1.16 afresh1 154: # Cleanup from previous runs.
155: rm -f $_cfile $_cfile.sig
156:
1.21 afresh1 157: _t=Get/Verify
1.17 afresh1 158:
1.11 afresh1 159: ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&
1.22 afresh1 160: echo "Cannot fetch SHA256.sig" >&2 && return 1
1.1 afresh1 161:
1.11 afresh1 162: # Verify signature file with public keys.
1.24 afresh1 163: ! $_unpriv -f "$_cfile" \
1.11 afresh1 164: signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
1.22 afresh1 165: echo "Signature check of SHA256.sig failed" >&2 && return 1
1.11 afresh1 166:
1.15 afresh1 167: for _d in $_drivers; do
1.39 afresh1 168: _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" | tail -1 )
1.19 afresh1 169: _installed=$(
1.22 afresh1 170: for fw in "${_pkgdir}/$_d-firmware"*; do
1.19 afresh1 171: [ -e "$fw" ] || continue
172: echo ${fw##*/}
173: done
1.21 afresh1 174: )
1.15 afresh1 175:
176: for _i in $_installed; do
177: if [ "$_f" = "$_i.tgz" ]; then
1.24 afresh1 178: echo "$_i already installed"
1.11 afresh1 179: continue 2
1.1 afresh1 180: fi
181: done
182:
1.11 afresh1 183: rm -f /tmp/h /tmp/fail
184:
185: # Fetch firmware file and create a checksum by piping through
186: # sha256. Create a flag file in case ftp failed. Firmware
187: # from net is written to the prefetch area.
188: ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |
189: ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||
190: unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )
191:
192: # Handle failed transfer.
193: if [[ -f /tmp/fail ]]; then
194: rm -f "$_tmpsrc/$_f"
1.22 afresh1 195: echo "Fetching of $_f failed!" >&2
196: continue
1.11 afresh1 197: fi
198:
199: # Verify firmware by comparing its checksum with SHA256.
1.22 afresh1 200: if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then
1.11 afresh1 201: [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"
1.22 afresh1 202: echo "Checksum test for $_f failed." >&2
203: continue
1.11 afresh1 204: fi
205:
206: # TODO: Check hash for files before deleting
1.22 afresh1 207: if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then
1.18 afresh1 208: echo "Uninstalling $_installed"
1.22 afresh1 209: cwd=${_pkgdir}/$_installed
1.11 afresh1 210:
211: set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"
212:
213: while read c g; do
214: case $c in
1.27 afresh1 215: @cwd) cwd="${DESTDIR}/$g"
1.11 afresh1 216: ;;
217: @*) continue
218: ;;
219: *) set -A _remove -- "$cwd/$c" "${_remove[@]}"
220: ;;
221: esac
1.22 afresh1 222: done < "${_pkgdir}/$_installed/+CONTENTS"
1.11 afresh1 223:
1.21 afresh1 224: # We specifically rm -f here because not removing files/dirs
225: # is probably not worth failing over.
1.11 afresh1 226: for _r in "${_remove[@]}" ; do
227: if [ -d "$_r" ]; then
228: # Try hard not to actually remove recursively
229: # without rmdir on the install media.
230: [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"
231: else
232: rm -f "$_r"
233: fi
234: done
235: fi
236:
1.21 afresh1 237: # TODO: Should we mark these so real fw_update can -Drepair?
1.25 afresh1 238: ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |
239: tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
1.28 afresh1 240: -s ",^firmware,${DESTDIR}/etc/firmware," \
1.25 afresh1 241: -C / -zxphf - "+*" "firmware/*"
1.23 afresh1 242:
1.22 afresh1 243: ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
1.1 afresh1 244: /^@comment pkgpath/ -1a
245: @option manual-installation
246: @option firmware
247: @comment install-script
248: .
249: w
250: EOL
1.11 afresh1 251: done
252: }
1.1 afresh1 253:
1.35 afresh1 254: fw_install "$FWURL"
FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>